c	Sampling bathymetry for MOST model usage
c	(c) Vasily Titov 1999

      program Bath_sample
      real*8 d(12000,12000)
      real*8 h11(12000), h22(12000)
      character*80 fname
      common /run/ t,n,npicx,npicy
      common /name/ fname
      data  mm,nn/12000,12000/
      
      write (*,*) 'Reading Bathymetry'
      call BathRead(d,h11,h22,m,n,mm,nn,0.1)
      write (*,*) 'Grid dimensions in X,Y:', m,n
 111  format ('Geographic area (E-W): ',F9.3,' -- ',F9.3)
 112  format ('Geographic area (S-N): ',F9.3,' -- ',F9.3)
      write (*,111) h11(1),h11(m)
      write (*,112) h22(1),h22(n)
      write (*,*) 'ALONG X:'
      write (*,*) 'Saving grid every n-th node, n='
      read (*,*) npicx
      write (*,*) '... starting from:'
      read (*,*) ns1
      write (*,*) ns1,h11(ns1),'degr E'
      write (*,*) '... until:'
      read (*,*) ne1
      write (*,*) ne1,h11(ne1),'degr E'
      write (*,*) 'ALONG Y:'
      write (*,*) 'Saving grid every n-th node, n='
      read (*,*) npicy
      write (*,*) '... starting from:'
      read (*,*) ns2
      write (*,*) ns2,h22(ns2),'degr N'
      write (*,*) '... until:'
      read (*,*) ne2
      write (*,*) ne2,h22(ne2),'degr N'
      call ExWrite(d,h11,h22,m,n,mm,nn,ns1,ns2,ne1,ne2)
      end
      
      subroutine ExWrite(d,h1,h2,n1,n2,mm,nn,ns1,ns2,ne1,ne2)
c.....Write  sampled surface for Explorer visualization
      real*8 d(mm,nn),h1(mm),h2(nn)
      character*80 sname
      common /run/ t,n,npicx,npicy
      common /name/ sname
      nc=index(sname,' ')
      sname(nc-1:nc)='.s'
      sname(nc+1:nc+1)='\0'
c      nc=index(sname,' ')
c      sname(nc:nc)='\0'
      write (*,*) 'Writing surface into file ', sname
      open (unit=1,file=sname,form='formatted')
      istep=npicx
      jstep=npicy
      write (*,*) 'New dimensions:',(ne1-ns1)/istep+1,(ne2-ns2)/jstep+1
      write (1,*) (ne1-ns1)/istep+1,(ne2-ns2)/jstep+1
 10   format(F20.13)
      do i=ns1,ne1,istep
         write (1,10) h1(i)
      end do
      do j=ne2,ns2,-jstep
         write(1,10) h2(j)
      end do
          
 666  format (4500F10.2)
      do j=ne2,ns2,-jstep
         write(1,666) (d(i,j),i=ns1,ne1,istep)
      end do
      close(unit=1,status='keep')
      return
      end

      subroutine BathRead(d,h1,h2,n1,n2,m,n,grnd)
c.....Reads bathymetry data in MOST format,
      real*8 d(m,n),h1(m),h2(n)
      character*80 fname
      common /name/ fname
      write(*,801)
 801  format(' Bathymetry filename: ',$)
      read(*,802) fname
 802  format(a)
      nc=index(fname,' ')
      fname(nc:nc)='\0'
      open(unit=1,file=fname,status='old'
     &     ,form='formatted')
      read (1,*) n1,n2
      read (1,*) (h1(i), i=1,n1)
      read (1,*) (h2(i), i=n2,1,-1)
      do i=1,n1
      	if (h1(i).LT.0.) h1(i)=360.+h1(i)
      end do
      do j=n2,1,-1
      	read (1,*) (d(i,j), i=1,n1)
      end do
      close(unit=1,status='keep')
      return
      end
