c0000000011111111112222222222333333333344444444445555555555666666666677777777778
c2345678901234567890123456789012345678901234567890123456789012345678901234567890
      subroutine fgennc(lon,lat,ncfn,ncid,HA_id)
      include 'netcdf.inc'
      character*80 ncfn
* error status return
      integer  iret
* netCDF id
      integer  ncid
* dimension ids
      integer  LON_dim
      integer  LAT_dim
* dimension lengths
      integer  LON_len
      integer  LAT_len
      parameter (LON_len = 1000)
      parameter (LAT_len = 1000)
* variable ids
      integer  LON_id
      integer  LAT_id
      integer  HA_id
* rank (number of dimensions) for each variable
      integer  LON_rank
      integer  LAT_rank
      integer  HA_rank
      parameter (LON_rank = 1)
      parameter (LAT_rank = 1)
      parameter (HA_rank = 2)
* variable shapes
      integer  LON_dims(LON_rank)
      integer  LAT_dims(LAT_rank)
      integer  HA_dims(HA_rank)
* data variables
      double precision  LON(LON_len)
      double precision  LAT(LAT_len)
* attribute vectors
      real  realval(1)
* enter define mode
c      write(*,*) ' create file: *',ncfn,'*'
      iret = nf_create(ncfn, NF_CLOBBER, ncid)
      call check_err(iret)
c      write(*,*) ' enter define mode'
* define dimensions
      iret = nf_def_dim(ncid, 'LON', LON_len, LON_dim)
      call check_err(iret)
      iret = nf_def_dim(ncid, 'LAT', LAT_len, LAT_dim)
      call check_err(iret)
* define variables
      LON_dims(1) = LON_dim
      iret = nf_def_var(ncid, 'LON', NF_DOUBLE, LON_rank, LON_dims, LON_
     1id)
      call check_err(iret)
      LAT_dims(1) = LAT_dim
      iret = nf_def_var(ncid, 'LAT', NF_DOUBLE, LAT_rank, LAT_dims, LAT_
     1id)
      call check_err(iret)
      HA_dims(2) = LAT_dim
      HA_dims(1) = LON_dim
      iret = nf_def_var(ncid, 'HA', NF_REAL, HA_rank, HA_dim
     1s, HA_id)
      call check_err(iret)
* assign attributes
      iret = nf_put_att_text(ncid, LON_id, 'units', 12, 'degrees_east')
      call check_err(iret)
      iret = nf_put_att_text(ncid, LON_id, 'point_spacing', 4, 'even')
      call check_err(iret)
      iret = nf_put_att_text(ncid, LAT_id, 'units', 13, 'degrees_north')
      call check_err(iret)
      iret = nf_put_att_text(ncid, LAT_id, 'point_spacing', 4, 'even')
      call check_err(iret)
      iret = nf_put_att_text(ncid, HA_id, 'units', 11, 'CENTIMETERS')
      call check_err(iret)
      realval(1) = -9.9999998e+33
      iret = nf_put_att_real(ncid, HA_id, 'missing_value', NF_REAL, 
     11, realval)
      call check_err(iret)
      realval(1) = -9.9999998e+33
      iret = nf_put_att_real(ncid, HA_id, '_FillValue', NF_REAL, 1, 
     1realval)
      call check_err(iret)
      iret = nf_put_att_text(ncid, HA_id, 'long_name', 14, 
     1 'Wave Amplitude')
      call check_err(iret)
      iret = nf_put_att_text(ncid, HA_id, 'history', 21, 'From surf_
     1reverse.dat')
      call check_err(iret)
      iret = nf_put_att_text(ncid, NF_GLOBAL, 'history', 28, 'FERRET V4.
     191 (GUI)  3-Dec-98')
      call check_err(iret)
* leave define mode
      iret = nf_enddef(ncid)
      call check_err(iret)
c      write(*,*) ' leave define mode'
* store LON
      iret = nf_put_var_double(ncid, LON_id, LON)
      call check_err(iret)
c      write(*,*) ' longitude stored'
* store LAT
      iret = nf_put_var_double(ncid, LAT_id, LAT)
      call check_err(iret)
c      write(*,*) ' latitude stored'
      end
       
c0000000011111111112222222222333333333344444444445555555555666666666677777777778
c2345678901234567890123456789012345678901234567890123456789012345678901234567890
      subroutine writerecs(ncid,HA_id,HA)
       
* netCDF id
      integer  ncid
* variable ids
      integer  HA_id
       
      include 'netcdf.inc'
* error status return
      integer  iret
       
* netCDF dimension sizes for dimensions used with record variables
      integer  LON_len
c..... LON_len = n_x
      integer  LAT_len
c..... LAT_len = n_y
      parameter (LON_len = 1000)
      parameter (LAT_len = 1000)
       
* rank (number of dimensions) for each variable
      integer  HA_rank
      parameter (HA_rank = 2)
* starts and counts for array sections of record variables
      integer  HA_start(HA_rank), HA_count(HA_rank)
      data HA_count /LON_len, LAT_len/
      data HA_start /1, 1/
       
* data variables
      
      double precision  HA(LON_len, LAT_len)
       
c..... check HA
c         zmin = 0.0
c         zmax = 0.0
c         do j=1,LAT_len
c            do i=1,LON_len
c               if(HA(i,j) .gt. zmax) then
c                  zmax = HA(i,j)
c               else if(HA(i,j) .lt. zmin) then
c                  zmin = HA(i,j)
c               endif
c            enddo
c         end do
c         write(*,*) ' inside max:',zmax,', min:',zmin
* store HA
c      write(*,*) ' store HA:',ncid,HA_id,HA_start,HA_count
c      write(*,*) ' HA_start:',(HA_start(i),i=1,HA_rank)
c      write(*,*) ' HA_count:',(HA_count(i),i=1,HA_rank)
      iret = nf_put_vara_double(ncid,HA_id,HA_start,HA_count,HA)
      call check_err(iret)
c      write(*,*) ' HA stored'
      end
       
      subroutine check_err(iret)
      integer iret
      include 'netcdf.inc'
      if (iret .ne. NF_NOERR) then
      print *, nf_strerror(iret)
      stop
      endif
      end
